#!/bin/sh
echo 'Content-type: text/html'  
echo ''

fqdn=""
read fqdn < /usr/local/root/ntp.conf

cat << EOS
<!DOCTYPE html>
<HTML>
<HEAD>
  <TITLE>NTP Setting</TITLE>
  <META charset="utf-8"/>
</HEAD>
<SCRIPT>
function set_ntp(){
	var txt = document.getElementById("fqdn");

	txt.disabled = true;
	document.getElementById("btn_set").disabled = true;

	var xhr = new XMLHttpRequest();
	xhr.open("POST", '/ntp/set_ntp_server.do', true);
	xhr.setRequestHeader("Content-Type", "text/plain");

	xhr.onreadystatechange = function() {
		if (this.readyState === XMLHttpRequest.DONE) {
			alert(this.status != 0 ? this.responseText : "Failed to connect to the server.");
			location.reload(true);
		}
	}

	xhr.send(txt.value);
}
</SCRIPT>
<BODY>
<h3>NTP Setting</h3>
EOS

echo  '<input id="fqdn" type="text" size="50" maxlength="253" value="'$fqdn'">'

cat << EOS
<button id="btn_set" onClick="set_ntp()">SET</button><BR><BR>
<div style="color:red;">NTP setting will take effect after reboot.</div>
<h3>NTP Sync Status</h3>
<PRE>
EOS

ERR=/tmp/ntp_`head -c 8 /dev/urandom | sha1sum | cut -d ' ' -f 1`
mkfifo $ERR
ntpq -p 2>$ERR &
if [ `cat $ERR  | wc -l` != 0 ]; then
	echo "NTP is not set correctly."
fi
rm $ERR

echo "</PRE>"
echo "</BODY>"
echo "</HTML>"
